/*!
 * @file guided_missile.h
 * @brief a GuidedMissile Projectile
*/

#ifndef _GUIDED_MISSILE_H
#define _GUIDED_MISSILE_H

#include "projectile.h"

class Vector;
class Weapon;
class ParticleSystem;
class ParticleEmitter;
class FastFactory;
class Aim;

class GuidedMissile : public Projectile
{
  public:
    GuidedMissile ();
    virtual ~GuidedMissile ();

    virtual void activate();
    virtual void deactivate();

    virtual void collidesWith(WorldEntity* entity, const Vector& location);

    virtual void destroy ();

    virtual void tick (float time);
    virtual void draw () const;


  private:
    static FastFactory*               fastFactory;
    static ParticleSystem*            trailParticles;
    static ParticleSystem*            explosionParticles;

    ParticleEmitter*                  emitter;
    float                             agility;
    float                             maxVelocity;

    WorldEntity* hitEntity; // FIXME TEMPORARY

};

#endif /* _GUIDED_MISSILE_H */
